//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

// VectorWorks
#include "VectorWorks/ISDK.h"
#include "VectorWorks/IApplication.h"
#include "VectorWorks/IDocument.h"

// VectorWorks::Debug
#include "VectorWorks/Debug/IDebugSupport.h"
#include "VectorWorks/Debug/IMemoryCollector.h"
#include "VectorWorks/Debug/IVWMemoryManager.h"

// VectorWorks::Filing
#include "VectorWorks/Filing/IFileIdentifier.h"
#include "VectorWorks/Filing/IFolderIdentifier.h"
#include "VectorWorks/Filing/IFileChooserDialog.h"
#include "VectorWorks/Filing/IFolderChooserDialog.h"
#include "VectorWorks/Filing/IRawOSFile.h"
#include "VectorWorks/Filing/IStdFile.h"
#include "VectorWorks/Filing/IXMLFile.h"
#include "VectorWorks/Filing/IXMLFileValidator.h"
#include "VectorWorks/Filing/IXMLSAXFile.h"
#include "VectorWorks/Filing/IApplicationFolders.h"
#include "VectorWorks/Filing/IImportExport3DS.h"
#include "VectorWorks/Filing/IImportExportSketchup.h"
#include "VectorWorks/Filing/IPathResolver.h"
#include "VectorWorks/Filing/IImportExportDWG.h"
#include "VectorWorks/Filing/IExportPDF.h"
#include "VectorWorks/Filing/IZIPFile.h"

// VectorWorks::Objects
#include "VectorWorks/Objects/IVWObject.h"
#include "VectorWorks/Objects/ILine2DObj.h"
#include "VectorWorks/Objects/ILocus2DObj.h"
#include "VectorWorks/Objects/ILocus3DObj.h"
#include "VectorWorks/Objects/IOvalObj.h"
#include "VectorWorks/Objects/IPolygon2DObj.h"
#include "VectorWorks/Objects/IPolygon3DObj.h"
#include "VectorWorks/Objects/IRectangleObj.h"
#include "VectorWorks/Objects/IRoundRectObj.h"

// VectorWorks::Math
#include "VectorWorks/Math/IPolyDef.h"
#include "VectorWorks/Math/IPolyDefArray.h"
#include "VectorWorks/Math/IPoly2DMath.h"
#include "VectorWorks/Math/IPoly2DOperations.h"
#include "VectorWorks/Math/ITrueTypeConv.h"

// VectorWorks::Workspaces
#include "VectorWorks/Workspaces/IWorkspaces.h"

// VectorWorks::UI
#include "VectorWorks/UI/IProgressDialog.h"
#include "VectorWorks/UI/IInfoBar.h"

// VectorWorks::Extension
#include "VectorWorks/Extension/IExtendedProps.h"
#include "VectorWorks/Extension/IExtensionParametric.h"
#include "VectorWorks/Extension/IExtensionMenu.h"
#include "VectorWorks/Extension/IExtensionTool.h"
#include "VectorWorks/Extension/IExtensionVSFunctions.h"
#include "VectorWorks/Extension/IObjUpdateSupport.h"
#include "VectorWorks/Extension/IProviderProtection.h"

// VectorWorks::VectorScript
#include "VectorWorks/VectorScript/IVectorScriptEditor.h"
#include "VectorWorks/VectorScript/IVectorScriptEngine.h"