//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#ifndef FOLDER_SPECIFIER_ENUM
#define FOLDER_SPECIFIER_ENUM

enum EFolderSpecifier {
	kRootFolderSpecifier	= 0,
	kApplicationFolder		= 1,
	kExternalsFolder		= 2,
	kExternalDataFolder		= 3,
	kWorkspacesFolder		= 4,
	kOverlaysFolder			= kWorkspacesFolder,
	kParametricsFolder		= 5,
	kDebugtoolsFolder		= 6,
	kTemplatesFolder		= 7,
	kStandardsFolder		= 8,
	kHelpFolder				= 9,
	kDictionariesFolder		= 10,
	kObjectLibrariesFolder  = 11,
	kAppDataFolder			= 12,
	kLibrariesFolder		= 13,
	kDefaultsFolder			= 14,
	kSettingsFolder			= 15,
	kObjectsImperialFolder	= 16,
	kObjectsMetricFolder	= 17,
	kPDFResourcesFolder		= 18,
	kCommonFolder			= 19,
	kCommonDataFolder		= 20,
	kCommonIncludesFolder   = 21,
	kCommonInterfacesFolder = 22,
	kFavoritesFolder		= 23,
	kIconsFolder			= 24,
	
	k_RESERVED_INTERNAL_OLDTemp = 68,		// not for use by SDK developers
	k_RESERVED_INTERNAL_OLDStan = 69,		// not for use by SDK developers
	k_RESERVED_INTERNAL_OLDEvntLyt = 139, // not for use by SDK developers

	kDefaultTexturesFolder			= 100,
	kDefaultCabinetHandlesFolder	= 101,
	kDefaultDoorHardwareFolder		= 102,
	kDefaultGradientsFolder			= 103,
	kDefaultHardscapeHatchesFolder	= 104,
	kDefaultHatchesFolder			= 105,
	kDefaultImageFillsFolder		= 106,
	kDefaultPlantsFolder			= 107,
	kDefaultToiletsFolder			= 108,
	kDefaultRWBackgroundsFolder		= 109,
	kDefaultSeatingLayoutFolder		= 110,
	kDefaultTileSymbolsFolder		= 111,
	kDefaultHumanFigTexturesFolder	= 112,
	kDefaultWallSlabStylesFolder		= 113,
	kDefaultStairsFolder			= 114,
	kDefaultTitleBlocksFolder		= 115,
	kDefaultSectionMarkersFolder	= 116,
	kDefaultRepetitiveUnitFolder	= 117,
	kDefaultDoorCustomLeavesFolder	= 118,
	kDefaultLightingGobosFolder		= 119,
	kDefaultReportsFolder			= 120,
	kDefaultLightingSymbolsFolder	= 121,
	kDefaultPlants2DSymbolsFolder	= 122,
	kDefaultPlants3DSymbolsFolder	= 123,
	kDefaultPlantsHatchesFolder		= 124,
	kDefaultRepetitiveFlooringFolder = 125,
	kDefaultRepetitiveFramingFolder = 126,
	kDefaultRepetitiveMasonryFolder	= 127,
	kDefaultRepetitiveMiscFolder	= 128,
	kDefaultRepetitiveRoofingFolder = 129,
	kDefaultRepetitiveSidingFolder	= 130,
	kDefaultWallSlabHatchesFolder		= 131,
	kDefaultWallSlabTexturesFolder		= 132,
	kDefaultWindowCustomShuttersFolder = 133,
	kDefaultSketchStylesFolder		= 134,
	kDefaultPlantListFolder			= 135,
	kDefaultPlantDatabaseFolder		= 136,
	kDefaultColorPalettesFolder		= 137,
	kDefaultFramingMemberProfileFolder = 138,
	kDefaultSpacesOccupantOrgFolder = 140,
	kDefaultSpacesNameListsFolder	= 141,
	kDefaultStructuralShapesFolder	= 142,
	kDefaultLandmarkSchedules		= 143,
	kDefaultVideoScreenFolder		= 144,
	kDefaultVSCasingsCRT43			= 145,
	kDefaultVSCasingsCRT169			= 146,
	kDefaultVSCasingsFlat43			= 147,
	kDefaultVSCasingsFlat169		= 148,
	kDefaultVSCasingsCRTCurved43	= 149,
	kDefaultVSScreenImages			= 150,
	kDefaultVSProjectorModels		= 151,
	kDefaultVSStandModels			= 152,
	kDefaultDashStylesFolder		= 153,
	kDefaultEventPlanningFolder		= 154,
	kDefaultEPRoom					= 155,
	kDefaultEPStage					= 156,
	kDefaultEPLectern				= 157,
	kDefaultEPScreen				= 158,
	kDefaultEPSeating				= 159,
	kDefaultEPStep					= 160,
	kDefaultCustomStair				= 161,
	kDefaultCustomStairStringers	= 162,
	kDefaultTilesFolder				= 163,
	kDefaultTextStylesFolder    	= 164,
	kDefaultFocusPointGraphics		= 165,
	kRenderworksFolder				= 166,
	kDefaultExistingTreeFolder		= 167,
	kDefaultHeliodonFolder			= 168,
	kDefaultHeliodonSymbolsFolder	= 169,
	kDefaultHeliodonCitiesFolder	= 170,
	kDefaultRenderStylesFolder		= 171,
	kDefaultStorySupportFolder		= 172
};

#endif
