//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

// Generic State Saver
// -------------------

template <class T> class TState {
private:
	T		fSaveState;
	T&		fStateVariable;
	
	DISALLOW_DUPLICATES(TState);
	
public:
	TState(T& stateVariable) : fStateVariable(stateVariable)
	{ fSaveState = fStateVariable; }
	TState(T& stateVariable, const T& newValue) : fStateVariable(stateVariable)
	{ fSaveState = fStateVariable; fStateVariable = newValue; }
	~TState()
	{ fStateVariable = fSaveState; }
};