//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

namespace VWFC
{
	namespace Math
	{
		class VWBodyEdge
		{
			friend class VWBody;
		public:
			// construction
							VWBodyEdge();
							VWBodyEdge(const VWBodyEdge& src);
			virtual			~VWBodyEdge();

			VWBodyEdge&		operator=(const VWBodyEdge& src);

			bool			IsValid() const;

		public:
			VWNURBSCurve	GetEdgeCurve();

		protected:
							VWBodyEdge(int edgeID);

			int				GetBodyEdgeID() const;
			void			SetBodyEdgeID(int id);

		private:
			IVWUnknown*	fp;
			int			fBodyEdgeID;
		};
	}
}