//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

namespace VWFC
{
	namespace Math
	{
		class VWBodyFace
		{
			friend class VWBody;
		public:
			// construction
							VWBodyFace();
							VWBodyFace(const VWBodyFace& src);
			virtual			~VWBodyFace();

			VWBodyFace&		operator=(const VWBodyFace& src);

			bool			IsValid() const;

		public:
			bool			GetPlanarSurface(VWPoint3D& outPlaneLocation, VWPoint3D& outPlaneNormal);
			bool			GetPlanarSurface(VWPlane& out);

		protected:
							VWBodyFace(int faceID);

			int				GetBodyFaceID() const;
			void			SetBodyFaceID(int id);

		private:
			IVWUnknown*	fp;
			int			fBodyFaceID;
		};
	}
}