//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

namespace VWFC
{
	namespace Math
	{
		class VWBodyEdge;
		class VWNURBSCurve
		{
			friend class VWBodyEdge;
		public:
			// construction
							VWNURBSCurve();
							VWNURBSCurve(const VWNURBSCurve& src);
			virtual			~VWNURBSCurve();

			VWNURBSCurve&	operator=(const VWNURBSCurve& src);

			bool			IsValid() const;

		public:
							void SetStartParameter(double startParam);
							void SetEndParameter(double endParam);
							double GetStartParameter();
							double GetEndParameter();
							int GetVWNURBSCurveID();
		protected:
							VWNURBSCurve(int curveID);
		private:
			IVWUnknown*	fp;
			int			fNURBSCurveID;
			double		fStartParam;
			double		fEndParam;
		};
	}
}