//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#pragma once

namespace VWFC
{
	namespace VWObjects
	{
		class VWClassAttributes;
		class VWObjectAttributes;

		class VWPattern
		{
			friend class VWClassAttributes;
			friend class VWObjectAttributes;
		public:
								VWPattern(InternalIndex fillIndex);
								VWPattern(short penIndex);
			virtual				~VWPattern();

			operator InternalIndex() const;
			operator short() const;

		public:
			Boolean				IsNonePattern() const;
			void				SetNonePattern();
			Boolean				IsSolidPattern() const;
			void				SetSolidPattern();
			Boolean				IsHatchPattern() const;
			Boolean				IsDashPattern() const;
			Boolean				IsGradientPattern() const;
			Boolean				IsImagePattern() const;
			Boolean				IsTilePattern() const;

		protected:
			bool				fbIsFillPattern;
			InternalIndex		fFillPatternIndex;
			short				fPenPatternIndex;
		};
	}
}