//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//
//
// Function constants that match up with the VLIB resources in the resource file.


#ifndef LibFuncConsts_H
#define LibFuncConsts_H


#if _WINDOWS

#include <Windows.h>
#include <GSWinSDK.h>	// Graphsoft Required

#endif


#include <GSESetup.h>
#include <MiniCadCallBacks.h>
#include <GSString.h>
#include <RecordHandler.h>




// VLIB ID numbers for the resources function procedures.

//------------------------------------------------------------------
// The following routine id constants must agree with the 'VLIB' resources
// and must be kept in sync with them.
// These MUST remain numbered in consecutive order.  The code loading stops as
// soon as it fails to find a VLIB resource.
//
const short kFunc1			= 0;
const short kFunc2			= 1;
const short kFunc3 			= 2;


#endif
