//
//	ModuleMain.cpp
//
//	Main entry point for Vectorworks module code.
//

#include "StdAfx.h"

#include "Tester/ExtObjThePoint.h"
#include "Tester/ExtObjTheLine.h"
#include "Tester/ExtObjTheRect.h"
#include "Tester/ExtObjThePoly2D.h"
#include "Tester/ExtObjThePoly3D.h"

//------------------------------------------------------------------
// Entry point of the module plug-in for Vectorworks
// More info at: http://developer.vectorworks.net/index.php?title=SDK:Module_Plug-in
//
extern "C" long GS_EXTERNAL_ENTRY plugin_main(long action, void* pInfo, long& ioData, CallBackPtr cbp)
{
	// initialize VCOM mechanizm
	::GS_InitializeVCOM( cbp );

	// init legacy Global Callback Pointer
	// for support of legacy GS_ functions
	gCBP	= cbp;

	{ // Init gSDK
		using namespace VectorWorks;
		VCOMPtr<ISDK>	localSDK( IID_SDK );
		gSDK	= localSDK;
	}

	long	reply	= 0L;

	using namespace VWFC::PluginSupport;

	REGISTER_Extension<Tester::CExtObjThePointDefTool>( GROUPID_ExtensionTool, action, pInfo, ioData, cbp, reply );
	REGISTER_Extension<Tester::CExtObjThePoint>( GROUPID_ExtensionParametric, action, pInfo, ioData, cbp, reply );

	REGISTER_Extension<Tester::CExtObjTheLineDefTool>( GROUPID_ExtensionTool, action, pInfo, ioData, cbp, reply );
	REGISTER_Extension<Tester::CExtObjTheLine>( GROUPID_ExtensionParametric, action, pInfo, ioData, cbp, reply );

	REGISTER_Extension<Tester::CExtObjTheRectDefTool>( GROUPID_ExtensionTool, action, pInfo, ioData, cbp, reply );
	REGISTER_Extension<Tester::CExtObjTheRect>( GROUPID_ExtensionParametric, action, pInfo, ioData, cbp, reply );

	REGISTER_Extension<Tester::CExtObjThePoly2DDefTool>( GROUPID_ExtensionTool, action, pInfo, ioData, cbp, reply );
	REGISTER_Extension<Tester::CExtObjThePoly2D>( GROUPID_ExtensionParametric, action, pInfo, ioData, cbp, reply );

	REGISTER_Extension<Tester::CExtObjThePoly3DDefTool>( GROUPID_ExtensionTool, action, pInfo, ioData, cbp, reply );
	REGISTER_Extension<Tester::CExtObjThePoly3D>( GROUPID_ExtensionParametric, action, pInfo, ioData, cbp, reply );

	return reply;
}
