#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtObjTheRect.h"

using namespace Tester;

namespace Tester
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"SampleToolDef_Rect",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*Reserved3*/					0,
		/*Reserved4*/					0,
		/*Message*/						{11200, 4},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{11200, 2},
		/*Category*/					{11200, 3},
		/*HelpText*/					{11200},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0,
		/*contextual help*/				"",
		/*Icon Specifier*/				"DefaultTools/ExtObjTheRectDefTool.png",
		/*Cursor Specifier*/			""
	};

	// --------------------------------------------------------------------------------------------------------
	static SParametricDef gParametricDef = {
		/*LocalizedName*/			{11200, 1},
		/*SubType*/					kParametricSubType_Rectangular,
		/*ResetOnMove*/				false,
		/*ResetOnRotate*/			false,
		/*WallInsertOnEdge*/		false,
		/*WallInsertNoBreak*/		false,
		/*WallInsertHalfBreak*/		false,
		/*WallInsertHideCaps*/		false,
	};
/*
	static SParametricParamChc	gArrChoices[] = {
		{ 128,	"Line",					{11002, 1} },
		{ 128,	"Arc",					{11002, 2} },
		{ 128,	"Bezier",				{11002, 3} },
		{ 128,	"None",					{11002, 4} },
		//------
		{ 129,	"Default Legend",		{11002, 5} },
		//------
		// TERMINATE
		{ NULL, NULL, {0,0} }
	};
*/
	static SParametricParamDef gArrParameters[] = {
		{ "p1",			{11001, 1},		"False",	"False",	kFieldBoolean,		0 },
		{ "p2",			{11001, 2},		"False",	"False",	kFieldBoolean,		0 },
		{ "p3",			{11001, 3},		"",			"",			kFieldText,			0 },
		{ "p4",			{11001, 4},		"",			"",			kFieldText,			0 },
		{ "p5",			{11001, 5},		"2\"",		"2\"",		kFieldCoordDisp,	0 },
		{ "p6",			{11001, 6},		"Auto",		"Auto",		kFieldPopUp,		128 },
		{ "p7",			{11001, 7},		"Auto",		"Auto",		kFieldPopUp,		129 },
		// TERMINATE
		{ NULL, {0,0}, NULL, NULL, EFieldStyle(0), 0 }
	};
}


// --------------------------------------------------------------------------------------------------------
// {088B350E-BFF8-47B3-AC30-AC0BE5FBF7C4}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjTheRect,
	/*Event sink*/		CObjTheRect_EventSink,
	/*Universal name*/	"SampleToolDef_Rect",
	/*Version*/			1,
	/*UUID*/			0x88b350e, 0xbff8, 0x47b3, 0xac, 0x30, 0xac, 0xb, 0xe5, 0xfb, 0xf7, 0xc4 );

// Test with VectorScript:
// SetSelect(CreateCustomObject('SampleToolDef_Rect',0,0,0));

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheRect::CExtObjTheRect(CallBackPtr cbp)
	: VWExtensionParametric( cbp, gParametricDef, gArrParameters )
//	: VWExtensionParametric( cbp, gParametricDef, gArrParameters, gArrChoices )
{
}

CExtObjTheRect::~CExtObjTheRect()
{
}

// --------------------------------------------------------------------------------------------------------
// {34781EF5-35FD-4989-8ABC-7C5FAC8EDF0D}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjTheRectDefTool,
	/*Event sink*/		CExtObjTheRectDefTool_EventSink,
	/*Universal name*/	"SampleToolDef_RectTool",
	/*Version*/			1,
	/*UUID*/			0x34781ef5, 0x35fd, 0x4989, 0x8a, 0xbc, 0x7c, 0x5f, 0xac, 0x8e, 0xdf, 0xd );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheRectDefTool::CExtObjTheRectDefTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtObjTheRectDefTool::~CExtObjTheRectDefTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheRectDefTool_EventSink::CExtObjTheRectDefTool_EventSink(IVWUnknown* parent)
	: VWToolDefaultRect_EventSink( parent, "SampleToolDef_Point" )
{
}

CExtObjTheRectDefTool_EventSink::~CExtObjTheRectDefTool_EventSink()
{
}

void CExtObjTheRectDefTool_EventSink::Init(const TXString& universalName)
{
	SDefaultRectToolInfo	toolInfo	= this->GetToolInfo();

	toolInfo.fModeGroup	= 0;
	toolInfo.fCenterLineChoiceIndex	= 0;
	toolInfo.fEdgePlacementChoiceIndex	= 1;

	this->SetToolInfo( toolInfo );

	VWToolDefaultRect_EventSink::Init( universalName );
}

bool CExtObjTheRectDefTool_EventSink::DoSetUp(bool bRestore, const IToolModeBarInitProvider* modeBarInitProvider)
{
	const IToolModeBar2InitProvider* p2 = dynamic_cast<const IToolModeBar2InitProvider*> (modeBarInitProvider);
	if (p2)
	{
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonA.png");
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonB.png");
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonC.png");
	}
	return VWToolDefaultRect_EventSink::DoSetUp( bRestore, modeBarInitProvider );
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CObjTheRect_EventSink::CObjTheRect_EventSink(IVWUnknown* parent)
	: VWParametric_EventSink( parent )
{
}

CObjTheRect_EventSink::~CObjTheRect_EventSink()
{
}

EObjectEvent CObjTheRect_EventSink::OnInitXProperties(CodeRefID objectID)
{
	// obtain the interfact for accessing the extended properties
	using namespace VectorWorks::Extension;
	VCOMPtr<IExtendedProps>	extProps( IID_ExtendedProps );



	return kObjectEventNoErr;
}

EObjectEvent CObjTheRect_EventSink::Recalculate()
{
	VWPoint3D	offset( -500, 0, 0 );

	VWPolygon3DObj	poly;
	poly.AddVertex( offset + VWPoint3D(50, 100, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 0, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 1000, 0) );
	poly.AddVertex( offset + VWPoint3D(100, 800, 0) );
	poly.SetClosed( true );

	return kObjectEventNoErr;
}
